# -*-makefile-*-
#
# Copyright (C) 2012 by Michael Olbrich <m.olbrich@pengutronix.de>
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_IMX_TEST) += imx-test

#
# Paths and names
#
IMX_TEST_VERSION	:= 3.0.35-4.0.0
IMX_TEST_MD5		:= ef498a2efdd5d642534ad47933dde167
IMX_TEST		:= imx-test-$(IMX_TEST_VERSION)
IMX_TEST_URL		:= /$(IMX_TEST).tar.gz
IMX_TEST_DIR		:= $(BUILDDIR)/$(IMX_TEST)
IMX_TEST_LICENSE	:= unknown
IMX_TEST_DIR		:= $(BUILDDIR)/$(IMX_TEST)
IMX_TEST_SOURCE		:= $(SRCDIR)/$(IMX_TEST).tar.gz

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

IMX_TEST_CONF_TOOL	:= NO

IMX_TEST_MAKE_OPT = $(CROSS_ENV) PLATFORM=IMX6Q INCLUDE="-I$(KERNEL_HEADER_DIR)/include" test
# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

#$(STATEDIR)/imx-test.compile:
#	@$(call targetinfo)
#	@$(call touch)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

$(STATEDIR)/imx-test.install:
	@$(call targetinfo)
	@$(call world/install, IMX_TEST)
	@$(call touch)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

$(STATEDIR)/imx-test.targetinstall:
	@$(call targetinfo)

	@$(call install_init, imx-test)
	@$(call install_fixup, imx-test,PRIORITY,optional)
	@$(call install_fixup, imx-test,SECTION,base)
	@$(call install_fixup, imx-test,AUTHOR,"Yauhen Kharuzhy <y.kharuzhy@sam-solutions.net>")
	@$(call install_fixup, imx-test,DESCRIPTION,missing)

	@$(call install_tree, imx-test, 0, 0, $(PTXDIST_PLATFORMDIR)/packages/$(IMX_TEST), /unit_tests)

	@$(call install_finish, imx-test)

	@$(call touch)

# vim: syntax=make
